<?php

namespace App\Http\Controllers\Api;

use abdullahobaid\mobilywslaraval\Mobily;

use App\Models\Bank;
use App\Models\Rating;
use App\Models\Setting;
use Illuminate\Support\Facades\Auth;
use Validator;
use App\User;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Mail;

use Carbon\Carbon;
use App\Mail\DemoMail;

class UserController extends Controller
{

    public function signup($lang, Request $request)
    {
        $validator = Validator::make($request->all(), [
            'name' => 'unique:users',
            'phone' => 'unique:users',
            // 'email' => 'unique:users',
            'id_number' => 'unique:users'
        ]);
        if ($validator->passes()) {
            $user = new User;
            $user->name = $request->input('name');
            $user->phone = $request->input('phone');
            if ($request->input('email')) {
                $user->email = $request->input('email');
            }

            if ($request->photo) {
                $filename = md5($request['photo']->getClientOriginalName()) . '.' . $request['photo']->getClientOriginalExtension();
                $request['photo']->move(public_path('images/user'), $filename);
                $user->photo = $filename;
            }

            $user->id_number = $request->id_number;
            $user->lat = $request->lat;
            $user->lng = $request->lng;

            $user->confirm = 'false';
            $user->status = 'active';
            $user->password = request('password');
            $user->save();

            $arr['id'] = (string)$user->id;
            $arr['name'] = $user->name;
            if ($user->photo) {
                $arr['photo'] = asset('images/user/' . $user->photo);
            } else {
                $arr['photo'] = '';
            }
            $arr['phone'] = (string)$user->phone;
            if ($user->phone2) {
                $arr['phone2'] = (string)$user->phone2;
            } else {
                $arr['phone2'] = '';
            }
                         $arr['note'] = $user->note ? $user->note : "";

            $arr['email'] = $user->email;

            $arr['id_number'] = $user->id_number;
            $arr['lat'] = $user->lat;
            $arr['lng'] = $user->lng;
            if ($user->confirm == 'false') {
                $code = rand(00000, 99999);
                $user = User::where('id', $user->id)->first();
                //       Mobily::send('966' . $user->phone, '  كود التفعيل :  ' . $code);


                send($user->phone, '  كود التفعيل :  ' . $code);

                $arr['code'] = (string)$code;
            } else {
                $arr['code'] = '';

            }
            $arr['online'] = $user->online;

            $arr['confirm'] = $user->confirm;
            $arr['status'] = $user->status;
            return response()->json(['value' => true, 'data' => $arr]);
        } else {
            foreach ((array)$validator->errors() as $value) {

                if (isset($value['name'])) {
                    $lang == 'ar' ? $msg = 'اسم المستخدم موجود بالفعل ' : $msg = 'Invalid username';
                    return response()->json([
                        'error' => 2,
                        'value' => false,
                        'msg' => $msg
                    ]);
                } elseif (isset($value['phone'])) {
                    $lang == 'ar' ? $msg = 'رقم الجوال موجود بالفعل' : $msg = 'Invalid phone number';
                    return response()->json([
                        'error' => 3,
                        'value' => false,
                        'msg' => $msg
                    ]);

                } elseif (isset($value['id_number'])) {
                    $lang == 'ar' ? $msg = 'رقم الهوية او الاقامة موجود بالفعل' : $msg = 'Invalid id number';
                    return response()->json([
                        'error' => 5,
                        'value' => false,
                        'msg' => $msg
                    ]);
                } else {
                    $lang == 'ar' ? $msg = 'لم يتم التسجيل' : $msg = 'No registration';
                    return response()->json([
                        'error' => 0,
                        'value' => false,
                        'msg' => $msg
                    ]);
                }
            }
        }
    }

    public function signin($lang, Request $request)
    {


        $user = User::where(['phone' => $request->phone])->first();
        if (!$user) {
            $lang == 'ar' ? $msg = 'هذا المستخدم غير مسجل' : $msg = 'This user is not registered';
            return response()->json([
                'value' => false,
                'error' => '6',
                'msg' => $msg
            ]);
        }
        $data = ['phone' => $request->input('phone'), 'password' => $request->input('password')];

        $arr = [];
        if (Auth::attempt($data)) {
            $user = Auth::user();
            $arr['id'] = (string)$user->id;
            $arr['name'] = $user->name;
            $arr['phone'] = $user->phone;
            if ($user->phone2) {
                $arr['phone2'] = (string)$user->phone2;
            } else {
                $arr['phone2'] = '';
            }
            $arr['id_number'] = $user->id_number;
            if ($user->email) {
                $arr['email'] = $user->email;
            } else {
                $arr['email'] = "";
            }

                         $arr['note'] = $user->note ? $user->note : "";

            $arr['status'] = $user->status;
            $arr['lat'] = $user->lat;
            $arr['lng'] = $user->lng;
            $arr['confirm'] = $user->confirm;
            $arr['online'] = $user->online;
            if ($user->photo) {
                $arr['photo'] = asset('images/user/' . $user->photo);
            } else {
                $arr['photo'] = "";
            }
            if ($user->confirm == 'false') {
                $code = rand(000000, 999999);
                $user = User::where('id', $user->id)->first();
                //     Mobily::send('966' . $user->phone, '  كود التفعيل :  ' . $code);

                send($user->phone, '  كود التفعيل :  ' . $code);

                $arr['code'] = (string)$code;
            } else {
                $arr['code'] = '';

            }
            return response()->json(['value' => true, 'data' => $arr]);
        } else {
            $lang == 'ar' ? $msg = 'كلمة المرور غير صحيحة' : $msg = 'The password is incorrect';
            return response()->json([
                'value' => false,
                'msg' => $msg
            ]);
        }
    }

    public function update_profile(Request $request, $id, $lang)
    {
        $validator = Validator::make($request->all(), [
            'name' => 'max:100|unique:users,name,' . $id,
            'phone' => 'unique:users,phone,' . $id,
            //   'email' => 'unique:users,email,' . $id,
            'id_number' => 'unique:users,id_number,' . $id
        ]);
        if ($validator->passes()) {
            $update_profile = User::find($id);
            if ($request->name) {
                $update_profile->name = $request->name;
            }
            if ($request->phone) {
                $update_profile->phone = $request->phone;
            }
            if ($request->phone2) {
                $update_profile->phone2 = $request->phone2;
            }

            if ($request->id_number) {
                $update_profile->id_number = $request->id_number;
            }
            if ($request->lat) {
                $update_profile->lat = $request->lat;
            }
            if ($request->lng) {
                $update_profile->lng = $request->lng;
            }

            if ($request->photo) {
                $filename = md5($request['photo']->getClientOriginalName()) . '.' . $request['photo']->getClientOriginalExtension();
                $request['photo']->move(public_path('images/user'), $filename);
                $update_profile->photo = $filename;
            }


            if ($request->old_password && password_verify($request->old_password, $update_profile->password)) {
                if ($request->password && $request->password !== ' ') {
                    $update_profile->password = request('password');
                }
            } else {
                $lang == 'ar' ? $msg = 'رقم المرور الحالى غير صحيح ' : $msg = 'The current traffic number is incorrect';
                return response()->json([
                    'error' => 6,
                    'value' => false,
                    'msg' => $msg
                ]);
            }
            $update_profile->update();

            $arr['id'] = (string)$update_profile->id;
            $arr['name'] = $update_profile->name;
            $arr['phone'] = $update_profile->phone;

            if ($update_profile->phone2) {
                $arr['phone2'] = $update_profile->phone2;
            } else {
                $arr['phone2'] = '';
            }

            $arr['id_number'] = $update_profile->id_number;
            $arr['lat'] = $update_profile->lat;
            $arr['lng'] = $update_profile->lng;
            if ($update_profile->photo) {
                $arr['photo'] = asset('images/user/' . $update_profile->photo);
            } else {
                $arr['photo'] = "";
            }

            $arr['status'] = $update_profile->status;
            $arr['confirm'] = $update_profile->confirm;
            $arr['online'] = $update_profile->online;
            $arr['code'] = '';


            return response()->json(['value' => 'true', 'data' => $arr]);

        } else {
            foreach ((array)$validator->errors() as $value) {
                if (isset($value['name'])) {
                    $lang == 'ar' ? $msg = 'اسم المستخدم مستخدم من قبل ' : $msg = 'Invalid rname';
                    return response()->json([
                        'error' => 1,
                        'value' => false,
                        'msg' => $msg
                    ]);
                } elseif (isset($value['phone'])) {
                    $lang == 'ar' ? $msg = 'رقم الجوال مستخدم من قبل ' : $msg = 'Invalid phone number';
                    return response()->json([
                        'error' => 2,
                        'value' => false,
                        'msg' => $msg
                    ]);
                } elseif (isset($value['email'])) {
                    $lang == 'ar' ? $msg = 'البريد الالكترونى مستخدم من قبل ' : $msg = 'Invalid email number';
                    return response()->json([
                        'error' => 3,
                        'value' => false,
                        'msg' => $msg
                    ]);
                } elseif (isset($value['id_number'])) {
                    $lang == 'ar' ? $msg = 'رقم الهوية او الاقامة موجود بالفعل' : $msg = 'Invalid id number';
                    return response()->json([
                        'error' => 4,
                        'value' => false,
                        'msg' => $msg
                    ]);
                } else {
                    return response()->json([
                        'error' => 5,
                        'value' => false,
                    ]);
                }
            }
        }
    }


    public function update_online(Request $request, $id)
    {
        if ($request->online) {
            $update_profile = User::where('id', $id)->update(['online' => $request->online]);
            return response()->json(['value' => 'true']);
        }
        return response()->json(['value' => 'false']);

    }


    public function uploadImage(Request $request)

    {
        $validator = Validator::make($request->all(), [
            'image' => 'max:9069|mimes:jpg,png,jpeg',
        ],
            [
                'image.mimes' => 'الامتدادات المسموح بها هى png - jpg - jpeg',
                'image.max' => 'اقصى حجم للصوره 9 ميجا',
            ]);

        if ($validator->fails()) {
            return response()->json(['status' => '0', 'message' => $validator->errors()->all()]);
        }
        $photo = $request->file('image');
        if (!is_null($photo)) {
            $extension = $photo->getClientOriginalExtension();

            $imgName = str_random(10) . '.' . $extension;
            $photo->move('images/user/', $imgName);


            $response = [
                'image' => $imgName,
                'fullUrl' => asset('images/user/' . $imgName),
            ];

            return $response;
        }
        return response()->json(['status' => '0', 'message' => 'لم يتم رفع الصوره']);
    }

    public function user_profile($id)
    {

        $user = User::where('id', $id)->first();

        if ($user) {
            $arr['id'] = (string)$user->id;
            $arr['name'] = $user->name;
            $arr['phone'] = $user->phone;
            if ($user->phone2) {
                $arr['phone2'] = $user->phone2;
            } else {
                $arr['phone2'] = '';
            }

            if ($user->email) {
                $arr['email'] = $user->email;
            } else {
                $arr['email'] = "";
            }
            $arr['id_number'] = $user->id_number;
            $arr['lat'] = $user->lat;
            $arr['lng'] = $user->lng;
            if ($user->photo) {
                $arr['photo'] = asset('images/user/' . $user->photo);
            } else {
                $arr['photo'] = "";
            }


            $arr['status'] = $user->status;
            $arr['confirm'] = $user->confirm;
            $arr['online'] = $user->online;
            if ($user->pay) {
                $arr['pay'] = $user->pay;
            } else {
                $arr['pay'] = "0";
            }
            if ($user->note) {
                $arr['note'] = $user->note;
            } else {
                $arr['note'] = "";
            }
            $arr['code'] = '';
            $arr['ratio'] = Setting::value('ratio');

            $ratings = Rating::where('user_id', $id)->get();

            $data = [];
            foreach ($ratings as $rating) {
                $arr_rate['id'] = (string)$rating->id;
                $arr_rate['name'] = $rating->name;
                $arr_rate['note'] = $rating->note;
                $arr_rate['num_rate'] = (string)$rating->num_rate;
                $data[] = $arr_rate;
            }
            return response()->json(['value' => true, 'data' => $arr, 'rating' => $data]);

        }
        return response()->json(['value' => false]);

    }

    public function update_pay($id, Request $request)
    {

        $user = User::find($id);

        $user->pay += $request->pay;
        $user->update();

        return response()->json(['value' => true]);

    }


    public function confirm_user($id)
    {
        $code = rand(000000, 999999);
        $user = User::where('id', $id)->first();
        //      Mobily::send('966' . $user->phone, '  كود التفعيل :  ' . $code);
        send($user->phone, '  كود التفعيل :  ' . $code);

        $code_in = (string)$code;

        return response()->json(['value' => true, 'code' => $code_in]);

    }

    public function confirm_user_true($id)
    {
        $user = User::where(['id' => $id])->first();

        $user->update(array('confirm' => 'true'));
        $user->refresh();

        $arr['id'] = (string)$user->id;
        $arr['name'] = $user->name;
        $arr['phone'] = $user->phone;
        if ($user->phone2) {
            $arr['phone2'] = $user->phone2;
        } else {
            $arr['phone2'] = '';

        }
        if ($user->email) {
            $arr['email'] = $user->email;
        } else {
            $arr['email'] = "";
        }
        $arr['id_number'] = $user->id_number;
        $arr['lat'] = $user->lat;
        $arr['lng'] = $user->lng;
        $arr['photo'] = asset('images/user/' . $user->photo);


        $arr['status'] = $user->status;
        $arr['confirm'] = $user->confirm;
        $arr['online'] = $user->online;

        $arr['code'] = '';


        return response()->json(['value' => true, 'data' => $arr]);
    }

    public function reset_password(Request $request, $lang)
    {
        $user = User::where(['phone' => $request->phone])->first();

        if ($user) {
            $code = rand(000000, 999999);
            //  Mobily::send('966' . $user->phone, '  كود التفعيل :  ' . $code);
            send($user->phone, '  كود التفعيل :  ' . $code);

            $arr['id'] = (string)$user->id;
            $arr['name'] = $user->name;
            $arr['phone'] = $user->phone;
            if ($user->phone2) {
                $arr['phone2'] = $user->phone2;
            } else {
                $arr['phone2'] = '';
            }

            if ($user->email) {
                $arr['email'] = $user->email;
            } else {
                $arr['email'] = "";
            }
            $arr['id_number'] = $user->id_number;
            $arr['lat'] = $user->lat;
            $arr['lng'] = $user->lng;
            $arr['photo'] = asset('images/user/' . $user->photo);


            $arr['status'] = $user->status;
            $arr['confirm'] = $user->confirm;
            $arr['online'] = $user->online;
            $arr['code'] = (string)$code;
            return response()->json(['value' => true, 'data' => $arr]);
        } else {
            $lang == 'ar' ? $msg = 'المستخدم غير مسجل' : $msg = 'User not registered';
            return response()->json([
                'value' => false,
                'msg' => $msg
            ]);
        }
    }

    public function reset_password_true(Request $request, $id)
    {

        $user = User::where(['id' => $id])->first();

        $user->update(array('password' => $request->password));
        $user->refresh();
        $arr['id'] = (string)$user->id;
        $arr['name'] = $user->name;
        $arr['phone'] = $user->phone;
        if ($user->phone2) {
            $arr['phone2'] = $user->phone2;
        } else {
            $arr['phone2'] = '';
        }
        if ($user->email) {
            $arr['email'] = $user->email;
        } else {
            $arr['email'] = "";
        }
        $arr['id_number'] = $user->id_number;
        $arr['lat'] = $user->lat;
        $arr['lng'] = $user->lng;
        $arr['photo'] = asset('images/user/' . $user->photo);


        $arr['status'] = $user->status;
        $arr['confirm'] = $user->confirm;
        $arr['online'] = $user->online;
        $arr['code'] = '';

        return response()->json(['value' => true, 'data' => $arr]);

    }


//    public function cities($lang)
//    {
//
//        $cities = City::all();
//        $data = [];
//        foreach ($cities as $city) {
//            $arr['id'] = $city->id;
//            if ($lang == 'ar') {
//                $arr['name'] = $city->name['ar'];
//            } else {
//                $arr['name'] = $city->name['en'];
//            }
//            $data[] = $arr;
//        }
//        return response()->json(['value' => true, 'data' => $data]);
//
//
//    }

//    public function contacts(Request $request)
//    {
//
//        $contact = new Contact();
//        $contact->name = $request->name;
//        $contact->phone = $request->phone;
//        $contact->email = $request->email;
//        $contact->message = $request->message;
//        $contact->save();
//
//        return response()->json(['value' => true]);
//
//
//    }

    public function about_us($lang)
    {
        $about = Setting::value('about_us');

        if ($lang == 'ar') {
            $arr['about'] = $about['ar'];
        } else {
            $arr['about'] = $about['en'];
        }

        return response()->json(['value' => true, 'data' => $arr]);

    }


    public function pledge($lang)
    {
        $pledge = Setting::value('pledge');

        if ($lang == 'ar') {
            $arr['pledge'] = $pledge['ar'];
        } else {
            $arr['pledge'] = $pledge['en'];
        }

        return response()->json(['value' => true, 'data' => $arr]);

    }

    public function policy($lang)
    {
        $policy = Setting::value('policy');

        if ($lang == 'ar') {
            $arr['policy'] = $policy['ar'];
        } else {
            $arr['policy'] = $policy['en'];
        }

        return response()->json(['value' => true, 'data' => $arr]);

    }

    public function banks($lang)
    {
        $banks = Bank::all();

        $data = [];
        foreach ($banks as $bank) {
            $arr['id'] = $bank->id;
            if ($lang == 'ar') {
                $arr['name'] = $bank->name['ar'];
            } else {
                $arr['name'] = $bank->name['en'];
            }
            $arr['num_bank'] = (string)$bank->num_bank;
            $arr['iban_number'] = (string)$bank->iban_number;
            $arr['image'] = asset('images/bank') . '/' . $bank->image;


            $data[] = $arr;
        }
        return response()->json(['value' => true, 'data' => $data]);

    }

    public function user_view($id, $lang, Request $request)
    {

        $user = User::find($id);

        if ($user) {
            $arr['id'] = (string)$user->id;
            $arr['name'] = $user->name;
            $arr['phone'] = $user->phone;
            $arr['note'] = $user->note;
            if ($user->phone2) {
                $arr['phone2'] = $user->phone2;
            } else {
                $arr['phone2'] = '';
            }

            if ($user->photo) {
                $arr['photo'] = asset('images/user/' . $user->photo);
            } else {
                $arr['photo'] = null;
            }
            $arr['distance'] = (string)$user->getDistanceBetweenPoints($request->lat, $request->lng, $lang);

            $ratings = Rating::where('user_id', $id)->get();

            $data = [];
            foreach ($ratings as $rating) {

                $arr_rate['id'] = (string)$rating->id;
                $arr_rate['name'] = $rating->name;
                $arr_rate['note'] = $rating->note;
                $arr_rate['num_rate'] = (string)$rating->num_rate;

                $data[] = $arr_rate;
            }

            return response()->json(['value' => true, 'data' => $arr, 'rating' => $data]);
        }
        return response()->json(['value' => false]);
    }

    public function add_rating(Request $request)
    {
        $rating = new rating();
        $rating->name = $request->name;
        $rating->note = $request->note;
        $rating->num_rate = (string)$request->num_rate;
        $rating->user_id = $request->user_id;
        $rating->save();

        $ratings = Rating::where('user_id', $rating->user_id)->get();

        $data = [];
        foreach ($ratings as $rating) {

            $arr_rate['id'] = (string)$rating->id;
            $arr_rate['name'] = $rating->name;
            $arr_rate['note'] = $rating->note;
            $arr_rate['num_rate'] = (string)$rating->num_rate;

            $data[] = $arr_rate;
        }
        return response()->json(['value' => true, 'data' => $data]);

    }

    public function users(Request $request, $lang)
    {
        if ($request->lat && $request->lng) {
            $lat = $request->lat;
            $lng = $request->lng;
            $max_distance = 200;
            $lat_small = $lat - ($max_distance * 0.018);
            $lat_large = $lat + ($max_distance * 0.018);
            $lng_small = $lng - ($max_distance * 0.018);
            $lng_large = $lng + ($max_distance * 0.018);
            $users = User::whereBetween('lat', [$lat_small, $lat_large])->whereBetween('lng', [$lng_small, $lng_large])->get();
            // $users = User::all();
            $data = [];

            foreach ($users as $user) {
                $arr['id'] = (string)$user->id;
                $arr['name'] = $user->name;
                $arr['photo'] = $user->photo ? asset('images/user/' . $user->photo) : "";
                $arr['lat'] = $user->lat;
                $arr['lng'] = $user->lng;
                $arr['distance'] = (string)$user->getDistanceBetweenPoints($request->lat, $request->lng, $lang);
                $data[] = $arr;
            }
            return response()->json(['value' => true, 'data' => $data]);
        }
        return response()->json(['value' => false]);

    }

    public function user_note(Request $request, $id)
    {

        $user = User::find($id);

        if ($request->note) {

            $user->note = $request->note;

            $user->update();
            return response()->json(['value' => true]);

        }
        return response()->json(['value' => false]);


    }


    public function my_location(Request $request, $id)
    {

        $user = User::find($id);

        if ($user != null) {

            $user->lat = $request->lat;
            $user->lng = $request->lng;

            $user->update();
            return response()->json(['value' => true]);

        }
        return response()->json(['value' => false]);


    }


}
