@extends('admin.layouts.app')
@section('title',$module_name)
@section('style')
    <link href="{{asset('panel/assets/plugins/summernote/summernote.css')}}" rel="stylesheet"/>
@stop
@section('content')
    <div class="content">
        <div class="container">
            <div class="row">
                <div class="col-lg-12">
                    <div class="card-box">
                        <h4 class="m-t-0 header-title"><b><i class="icon-pencil before_word"></i>&nbsp;
                                إضافة {{ $single_module_name }}
                            </b>
                            <hr>
                        </h4>
                        {!! Form::open(['method'=>'post', 'files'=>true, 'enctype' => 'multipart/form-data', 'route'=>[$route.'.store'], 'class' => 'form-row-seperated add_ads_form']) !!}
                        <div class="row">
                            <div class="col-md-12">
                                @foreach($create_fields as $labels => $fields)
                                    @foreach($languages as $language_key => $language_value)
                                        <div class="form-group{{ $errors->has($fields.'_'.$language_key) ? ' has-error' : '' }}">
                                            <label for="{{$fields.'_'.$language_key}}">{{ $labels.$language_value}}</label>
                                            @if($fields == 'note')
                                                {!! Form::textarea($fields.'_'.$language_key, null, ['class'=>'form-control']) !!}
                                            @else
                                                {!! Form::text($fields.'_'.$language_key, null, ['class'=>'form-control']) !!}
                                            @endif
                                        </div>
                                        <br>
                                    @endforeach
                                @endforeach
                                <br>
                                <div>
                                    <label for="title">الصور</label>
                                    <input type="file" name="image"
                                           data-default-file="{{asset('images/logo/default.png')}}"
                                           id="input-file-now-custom-1"
                                           class="dropify">
                                    @if ($errors->has('image'))
                                        <small class="text-danger">{{ $errors->first('image') }}</small>
                                    @endif
                                </div>

                                <br>
                                    <div class="form-group">
                                        <label class="control-label">الحالة</label>
                                        {{ Form::select('status', $status, null, array('class' => 'form-control select2 select2-hidden-accessible','tabindex'=>-1,'aria-hidden'=>true, 'required')) }}
                                        @if ($errors->has('status'))
                                            <small class="text-danger">{{ $errors->first('status') }}</small>
                                        @endif
                                    </div>
                                <div class="form-group">
                                    <div class="control-label col-md-push-1">
                                        <button type="submit"
                                                class="update_button btn btn-success btn-rounded waves-effect waves-light">
                                            إضافة
                                        </button>
                                    </div>
                                </div>
                            </div>

                        </div>
                        {!! Form::close() !!}
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection
@section('script')
    <script>
        $(document).ready(function () {
            // Basic
            $('.dropify').dropify();
            // Translated
            $('.dropify-fr').dropify({
                messages: {
                    default: 'Glissez-déposez un fichier ici ou cliquez',
                    replace: 'Glissez-déposez un fichier ou cliquez pour remplacer',
                    remove: 'Supprimer',
                    error: 'Désolé, le fichier trop volumineux'
                }
            });
            // Used events
            var drEvent = $('#input-file-events').dropify();
            drEvent.on('dropify.beforeClear', function (event, element) {
                return confirm("Do you really want to delete \"" + element.file.name + "\" ?");
            });
            drEvent.on('dropify.afterClear', function (event, element) {
                alert('File deleted');
            });
            drEvent.on('dropify.errors', function (event, element) {
                console.log('Has Errors');
            });
            var drDestroy = $('#input-file-to-destroy').dropify();
            drDestroy = drDestroy.data('dropify')
            $('#toggleDropify').on('click', function (e) {
                e.preventDefault();
                if (drDestroy.isDropified()) {
                    drDestroy.destroy();
                } else {
                    drDestroy.init();
                }
            })
        });
    </script>
@stop